//
//  OSVersion.h
//  AraeliumFoundation
//
//  Created by Seth Willits on 11/16/11.
//  Copyright 2011 Araelium Group. All rights reserved.
//

#import <Cocoa/Cocoa.h>


enum {
	OSXVersionMajorMinorMask = 0x00FFFF00,
	OSXVersion10_15 = 0x000A0F00,
	OSXVersion10_14 = 0x000A0E00,
	OSXVersion10_13 = 0x000A0D00,
	OSXVersion10_12 = 0x000A0C00,
	OSXVersion10_11 = 0x000A0B00,
	OSXVersion10_10 = 0x000A0A00,
	OSXVersion10_9 = 0x000A0900,
	OSXVersion10_8 = 0x000A0800,
	OSXVersion10_7 = 0x000A0700,
	OSXVersion10_6 = 0x000A0600,
};

uint32_t OSXVersion(void);
uint32_t OSXVersionMake(int major, int minor, int bugfix);

#define IsSnowLeopard()			((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_6)
#define IsSnowLeopardOrLater()	((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_6)
#define IsLion()				((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_7)
#define IsLionOrLater()			((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_7)
#define IsMountainLion()		((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_8)
#define IsMountainLionOrLater()	((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_8)
#define IsMavericks()		    ((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_9)
#define IsMavericksOrLater()	((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_9)
#define IsYosemite()			((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_10)
#define IsYosemiteOrLater()		((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_10)
#define IsElCapitan()			((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_11)
#define IsElCapitanOrLater()	((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_11)
#define IsSierra()			    ((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_12)
#define IsSierraOrLater()	    ((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_12)
#define IsHighSierra()			((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_13)
#define IsHighSierraOrLater()	((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_13)
#define IsMojave()				((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_14)
#define IsMojaveOrLater()		((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_14)
#define IsCatalina()			((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_15)
#define IsCatalinaOrLater()		((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_15)

#define OXVersionIs_10_6()			((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_6)
#define OXVersionIs_10_7()			((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_7)
#define OXVersionIs_10_8()			((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_8)
#define OXVersionIs_10_9()			((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_9)
#define OXVersionIs_10_10()			((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_10)
#define OXVersionIs_10_11()			((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_11)
#define OXVersionIs_10_12()			((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_12)
#define OXVersionIs_10_13()			((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_13)
#define OXVersionIs_10_14()			((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_14)
#define OXVersionIs_10_15()			((OSXVersion() & OSXVersionMajorMinorMask) == OSXVersion10_15)

#define OXVersionIs_10_6_OrLater()	((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_6)
#define OXVersionIs_10_7_OrLater()	((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_7)
#define OXVersionIs_10_8_OrLater()	((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_8)
#define OXVersionIs_10_9_OrLater()	((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_9)
#define OXVersionIs_10_10_OrLater()	((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_10)
#define OXVersionIs_10_11_OrLater()	((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_11)
#define OXVersionIs_10_12_OrLater()	((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_12)
#define OXVersionIs_10_13_OrLater()	((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_13)
#define OXVersionIs_10_14_OrLater()	((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_14)
#define OXVersionIs_10_15_OrLater()	((OSXVersion() & OSXVersionMajorMinorMask) >= OSXVersion10_15)

